Main Page Modules Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# deSceneRoom Class Reference

`#include <deScene_priv.hpp>`

Inheritance diagram for deSceneRoom:

[legend]
Collaboration diagram for deSceneRoom:

[legend]
List of all members.

## Public Member Functions
| deSceneRoom ()
virtual | ~deSceneRoom ()
void * | GetWOInterface (long interface_id)
deBoolean | DeSerializeLoad ()
void | SetRoomListPtr (void *ptr)
void * | GetRoomListPtr ()
long | Traverse (IdeSceneGraph::deSceneTraversal *Params)
deBoolean | TestCollision (const IdeCollision::deCollideParams &Params, IdeCollision *Collision)
long | GetPassNum ()
void | GetAABB (deVec3d &Min, deVec3d &Max)
void | SetContents (DWORD contents)
DWORD | GetContents ()
deBoolean | AddSceneObject (IdeSceneObject *obj)
| add an IdeSceneObject to the scene room
deBoolean | AddPortal (IdePortal *portal)
| add a portal to the scene room
deBoolean | RemoveSceneObject (IdeSceneObject *obj)
| remove an IdeSceneObject from the scene room
## Public Attributes
| WorldObjectClassDef
## Protected Member Functions
int | ViewCullObjectList (IdeCamera *c, const IdePlaneFrustum *f, deTList< IdeSceneObject * > &inout)
## Protected Attributes
deTList< IdePortal * > | m_PortalList
deTList< IdeSceneObject * > | m_Objects
deVec3d | m_Min
deVec3d | m_Max
DWORD | m_Contents
void * | m_RoomListPtr
## Private Member Functions
virtual int | TraverseRoom (IdeSceneGraph::deSceneTraversal *)
virtual deBoolean | TestRoomCollision (const IdeCollision::deCollideParams &, IdeCollision *)
## Private Attributes
int | m_CurrentPassNum
deTArray< deIDPair > | m_CachedObjects

## Constructor & Destructor Documentation

deSceneRoom::deSceneRoom | ( |  | ) |

deSceneRoom::~deSceneRoom | ( |  | ) | `[virtual]`

## Member Function Documentation

deBoolean deSceneRoom::AddPortal | ( | IdePortal * | portal | ) | `[virtual]`

| add a portal to the scene room Implements IdeSceneRoom.

deBoolean deSceneRoom::AddSceneObject | ( | IdeSceneObject * | obj | ) | `[virtual]`

| add an IdeSceneObject to the scene room Implements IdeSceneRoom.

deBoolean deSceneRoom::DeSerializeLoad | ( |  | ) | `[virtual]`

| Call after all objects in a world have been loaded, to allow pointers to be correctly resolved from World and Object ID's Reimplemented from deWorldObject.

void deSceneRoom::GetAABB | ( | deVec3d & | Min,
|  | deVec3d & | Max
| ) | `[virtual]`

| Implements IdeSceneRoom.

DWORD deSceneRoom::GetContents | ( |  | ) | `[virtual]`

| Implements IdeSceneRoom.

long deSceneRoom::GetPassNum | ( |  | ) | `[virtual]`

| Implements IdeSceneRoom.

void * deSceneRoom::GetRoomListPtr | ( |  | ) | `[virtual]`

| Implements IdeSceneRoom.

void * deSceneRoom::GetWOInterface | ( | long | interface_id | ) | `[virtual]`

| request a related interface, identified with an ID originally returned from IdeWorldManager::GetUniqueWOInterfaceID Implements IdeWorldObject.

deBoolean deSceneRoom::RemoveSceneObject | ( | IdeSceneObject * | obj | ) | `[virtual]`

| remove an IdeSceneObject from the scene room Implements IdeSceneRoom.

void deSceneRoom::SetContents | ( | DWORD | contents | ) | `[virtual]`

| Implements IdeSceneRoom.

void deSceneRoom::SetRoomListPtr | ( | void * | ptr | ) | `[virtual]`

| Implements IdeSceneRoom.

deBoolean deSceneRoom::TestCollision | ( | const IdeCollision::deCollideParams & | Params,
|  | IdeCollision * | Collision
| ) | `[virtual]`

| Implements IdeSceneRoom.

virtual deBoolean deSceneRoom::TestRoomCollision | ( | const IdeCollision::deCollideParams & | ,
|  | IdeCollision * |
| ) | `[inline, private, virtual]`

long deSceneRoom::Traverse | ( | IdeSceneGraph::deSceneTraversal * | Params | ) | `[virtual]`

| Implements IdeSceneRoom.

virtual int deSceneRoom::TraverseRoom | ( | IdeSceneGraph::deSceneTraversal * |  | ) | `[inline, private, virtual]`

int deSceneRoom::ViewCullObjectList | ( | IdeCamera * | c,
|  | const IdePlaneFrustum * | f,
|  | deTList< IdeSceneObject * > & | inout
| ) | `[protected]`

## Member Data Documentation

deTArray<deIDPair> deSceneRoom::m_CachedObjects`[private]`

DWORD deSceneRoom::m_Contents`[protected]`

int deSceneRoom::m_CurrentPassNum`[private]`

deVec3d deSceneRoom::m_Max`[protected]`

deVec3d deSceneRoom::m_Min`[protected]`

deTList<IdeSceneObject*> deSceneRoom::m_Objects`[protected]`

deTList<IdePortal*> deSceneRoom::m_PortalList`[protected]`

void* deSceneRoom::m_RoomListPtr`[protected]`

deSceneRoom::WorldObjectClassDef

The documentation for this class was generated from the following files:

- deScene_priv.hpp
- deSceneNode.cpp